unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Image1: TImage;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  GraphType, LCLType, IntfGraphics, FPImage,
  BGRABitmap, BGRABitmapTypes;

const
  IMG_WIDTH = 3000;
  IMG_HEIGHT = 3000;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
  p: PBGRAPixel;
  img: TBGRABitmap;
  t: TDateTime;
begin
  Image1.Picture.Clear;
  Image1.Refresh;

  t := now;
  img := TBGRABitmap.Create(IMG_WIDTH, IMG_HEIGHT);
  p := img.data;
  for i := 0 to img.NbPixels -1  do
  begin
    p^ := clBlue;
    inc(p);
  end;
  img.InvalidateBitmap;
  t := Now-t;
  Image1.Picture.Assign(img);
  img.free;

  Caption := 'BGRABitmap Data: ' + FormatDateTime('s.zzz "s"', t);
  Memo1.Lines.Add(Caption);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  bmp: TBitmap;
  x, y: Integer;
  t: TDateTime;
begin
  Image1.Picture.Clear;
  Image1.Refresh;

  t := Now;
  bmp := TBitmap.Create;
  bmp.SetSize(IMG_WIDTH, IMG_HEIGHT);;
  for y := 0 to bmp.Height-1 do
    for x := 0 to bmp.Width-1 do
      bmp.Canvas.Pixels[x, y] := clBlue;
  t := Now-t;
  Image1.Picture.Assign(bmp);
  bmp.Free;

  Caption := 'Bitmap Pixels: ' + FormatDateTime('s.zzz "s"', t);
  Memo1.Lines.Add(Caption);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  bmp: TBitmap;
  hBmp, hMask: THandle;
  img: TLazIntfImage;
  x, y: Integer;
  t: TDateTime;
begin
  Image1.Picture.Clear;
  Image1.Refresh;

  t := Now;
  bmp := TBitmap.Create;
  bmp.SetSize(IMG_WIDTH, IMG_HEIGHT);
  img := bmp.CreateIntfImage;
  for y := 0 to bmp.Height-1 do
    for x := 0 to bmp.Width-1 do
      img.Colors[x, y] := colBlue;
  img.CreateBitmaps(hBmp, hMask);
  bmp.Handle := hBmp;
  bmp.MaskHandle := hMask;
  t := Now-t;
  Image1.Picture.Assign(bmp);
  bmp.Free;
  Caption := 'LazIntfImage: ' + FormatDateTime('s.zzz "s"', t);
  Memo1.Lines.Add(Caption);
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  x, y: Integer;
  img: TBGRABitmap;
  t: TDateTime;
begin
  Image1.Picture.Clear;
  Image1.Refresh;

  t := now;
  img := TBGRABitmap.Create(IMG_WIDTH, IMG_HEIGHT);
  for y := 0 to IMG_HEIGHT-1 do
    for x := 0 to IMG_WIDTH-1 do
      img.SetPixel(x, y, clBlue);
  img.InvalidateBitmap;
  t := Now - t;
  Image1.Picture.Assign(img);
  img.free;

  Caption := 'BGRABitmap SetPixel: ' + FormatDateTime('s.zzz "s"', t);
  Memo1.Lines.Add(Caption);
end;

procedure TForm1.Button5Click(Sender: TObject);
const
  BLUE_QUAD: TRGBQuad = (
    rgbBlue: 255;
    rgbGreen: 0;
    rgbRed: 0;
    rgbReserved: 0);
var
  bmp: TBitmap;
  x, y: Integer;
  t: TDateTime;
  P: PRGBQuad;
begin
  Image1.Picture.Clear;
  Image1.Refresh;

  t := Now;
  bmp := TBitmap.Create;
  bmp.PixelFormat := pf32Bit;
  bmp.SetSize(IMG_WIDTH, IMG_HEIGHT);;
  for y := 0 to bmp.Height-1 do
  begin
    P := bmp.ScanLine[y];
    for x := 0 to bmp.Width-1 do
    begin
      P^ := BLUE_QUAD;
      inc(P);
    end;
  end;
  t := Now-t;
  Image1.Picture.Assign(bmp);
  bmp.Free;

  Caption := 'Bitmap ScanLine (32bit): ' + FormatDateTime('s.zzz "s"', t);
  Memo1.Lines.Add(Caption);
end;

procedure TForm1.Button6Click(Sender: TObject);
const
  BLUE_QUAD: TRGBQuad = (
    rgbBlue: 255;
    rgbGreen: 0;
    rgbRed: 0;
    rgbReserved: 0);
var
  bmp: TBitmap;
  img: TRawImage;
  x, y: Integer;
  t: TDateTime;
  P: PByte;
  P4: PRGBQuad absolute P;
begin
  Image1.Picture.Clear;
  Image1.Refresh;

  t := Now;
  bmp := TBitmap.Create;
  bmp.PixelFormat := pf32Bit;
  bmp.SetSize(IMG_WIDTH, IMG_HEIGHT);
  for y := 0 to bmp.Height-1 do
  begin
    P := bmp.RawImage.GetLineStart(y);
    for x := 0 to bmp.Width-1 do
    begin
      P4^ := BLUE_QUAD;
      inc(P4);
    end;
  end;
  t := Now-t;
  Image1.Picture.Assign(bmp);
  bmp.Free;

  Caption := 'Bitmap RawImage (32bit): ' + FormatDateTime('s.zzz "s"', t);
  Memo1.Lines.Add(Caption);
end;

procedure TForm1.Button7Click(Sender: TObject);
const
  BLUE_TRIPLE: TRGBTriple = (
    rgbtBlue: 255;
    rgbtGreen: 0;
    rgbtRed: 0);
var
  bmp: TBitmap;
  x, y: Integer;
  t: TDateTime;
  P: PRGBTriple;
begin
  Image1.Picture.Clear;
  Image1.Refresh;

  t := Now;
  bmp := TBitmap.Create;
  bmp.PixelFormat := pf24Bit;
  bmp.SetSize(IMG_WIDTH, IMG_HEIGHT);;
  for y := 0 to bmp.Height-1 do
  begin
    P := bmp.ScanLine[y];
    for x := 0 to bmp.Width-1 do
    begin
      P^ := BLUE_TRIPLE;
      inc(P);
    end;
  end;
  t := Now-t;
  Image1.Picture.Assign(bmp);
  bmp.Free;

  Caption := 'Bitmap ScanLine (24bit): ' + FormatDateTime('s.zzz "s"', t);
  Memo1.Lines.Add(Caption);
end;

procedure TForm1.Button8Click(Sender: TObject);
const
  BLUE_TRIPLE: TRGBTriple = (
    rgbtBlue: 255;
    rgbtGreen: 0;
    rgbtRed: 0);
var
  bmp: TBitmap;
  img: TRawImage;
  x, y: Integer;
  t: TDateTime;
  P: PByte;
  P3: PRGBTriple absolute P;
begin
  Image1.Picture.Clear;
  Image1.Refresh;

  t := Now;
  bmp := TBitmap.Create;
  bmp.PixelFormat := pf24Bit;
  bmp.SetSize(IMG_WIDTH, IMG_HEIGHT);
  for y := 0 to bmp.Height-1 do
  begin
    P := bmp.RawImage.GetLineStart(y);
    for x := 0 to bmp.Width-1 do
    begin
      P3^ := BLUE_TRIPLE;
      inc(P3);
    end;
  end;
  t := Now-t;
  Image1.Picture.Assign(bmp);
  bmp.Free;

  Caption := 'Bitmap RawImage (24bit): ' + FormatDateTime('s.zzz "s"', t);
  Memo1.Lines.Add(Caption);
end;

end.

